﻿using BlacksmithWorkshopContracts.BindingModels;
using BlacksmithWorkshopContracts.ViewModels;
using BlacksmithWorkshopDataModels.Enums;
using BlacksmithWorkshopDataModels.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection.PortableExecutable;
using System.Text;
using System.Threading.Tasks;

namespace BlacksmithWorkshopListImplement.Models
{
    //класс, реализующий интерфейс модели заказа
    public class Order : IOrderModel
    {
        //методы set сделали приватными, чтобы исключить неразрешённые манипуляции
        public int Id { get; private set; }

        public int ArticleId { get; private set; }

        public int Count { get; private set; }

        public double Sum { get; private set; }

        public OrderStatus Status { get; private set; }

        public DateTime DateCreate { get; private set; }

        public DateTime? DateImplement { get; private set; }

        public static Order? Create(OrderBindingModel? model)
        {
            if (model == null)
            {
                return null;
            }

            return new Order()
            {
                ArticleId = model.ArticleId,
                Count = model.Count,
                Sum = model.Sum,
                Status = model.Status,
                DateCreate = model.DateCreate, //а надо ли?
                DateImplement = model.DateImplement //а надо ли?
            };
        }

        //метод изменения существующего объекта
        public void Update(OrderBindingModel? model)
        {
            if(model == null)
            {
                return;
            }

            ArticleId = model.ArticleId;
            Count = model.Count;
            Sum = model.Sum;
            Status = model.Status;
            DateCreate = model.DateCreate; //а надо ли?
            DateImplement = model.DateImplement; //а надо ли?
        }

        //метод для создания объекта класса ViewModel на основе данных объекта класса-компонента
        public OrderViewModel GetViewModel() => new()
        {
            ArticleId = ArticleId,
            Count = Count,
            Sum = Sum,
            Status = Status,
            DateCreate = DateCreate, //а надо ли?
            DateImplement = DateImplement //а надо ли?
        };
    }
}
